#Demo8-1.ps1, utilise les loggers de la dmo 8
#Utilisation d'une proprit globale, voir Package

$LogPattern = "[%thread] %-5level %property{CallStack} - `%message%newline"

Function Une { $LogMain.Info("Dans la fonction Une")
Deux }

Function Deux { $LogMain.Info("Dans la fonction Deux")
Trois
}

Function Trois { $LogMain.Info("Dans la fonction Trois") }

 #Dclare une proprit active globale
Set-LogActiveProperty "CallStack" { $(ParseStack $(Get-CallStack)) }

 #Met  jour le layout de l'appender ROOT de LoggerMain
Update-LogLayout $LogMain.Logger.Parent.Appenders[0] $LogPattern

$LogMain.Info("Appel la fonction Une ")
Une
$LogMain.Info("Fin")

 #Met  jour le layout de l'appender nomm "ConsoleColoris" de LoggerMain
Update-LogLayout ( Get-LoggerAppender $LogMain  "ConsoleColoris") $LogPattern
 #Les 2 appenders utilisent la proprit active 'CallStack'
Une

"Code de la mthode ToString() de la proprit globale nomme 'CallStack' = $(Get-GlobalPropertyScript 'CallStack')"
#Modifie une proprit active globale
Set-LogActiveProperty "CallStack" {"Bonjour"}
Une

$global:Tab=@(1,2,3)
 #Ici on appelle la mthode ToString de l'objet System.Array 
 #Et on rfrence l'adresse du tableau courant. Si on le modifie par $Tab+=4, la rfrence mmorise ne pointera pas sur le nouveau tableau
 #On peut rfrencer n'importe quel objet, mais ce sera toujours sa mthode ToString qui sera appell
Set-LogGlobalProperty "CallStack" $Tab
 #Provoque une exception car la mthode toString est en code natif
"Code de la mthode ToString() de la proprit globale nomme 'CallStack' = $(Get-GlobalPropertyScript 'CallStack')"

Stop-Log