#Demo9.ps1
# Imbrication de contextes. On utilise une proprit locale

New-LogColoredConsoleAppender $LogDefaultColors|`
    #On ajoute un objet Layout  l'appender prcdement cr
    #!!!!!!!!!
    # Le premier paramtre attendu est renseign via le pipeleline,
    # on doit donc prciser le nom du paramtre ( -L ), sinon l'affectation se fait 
    # sur le premier paramtre, ce qui provoquera des erreurs de typage. 
    #!!!!!!!!!
 Add-LogLayout -L "[%thread] %-5level (%x) -%message%newline"|`
 Enable-LogAppender|`
   #Configure le framework avec l'appender provenant du pipeline
 Set-LogBasicConfigurator 
 
$LogMain  = Get-LogLogger "Main"


Function Une {
   #Dclare une proprit locale rfrence par la macro %x du layout de l'appender ROOT.
Push-ThreadContext "NDC" $($myinvocation.MyCommand)
$LogMain.Info("Dans la fonction Une")
Deux
 #on n'utilise pas la valeur de retour
$Null=Pop-ThreadContext "NDC"
#La proprit locale n'a plus d'existence
#On rfrencera dsormais celle sur le haut de la pile. 
}

Function Deux {
Push-ThreadContext "NDC" $($myinvocation.MyCommand)
$LogMain.Info("Dans la fonction Deux")
Trois
$Null=Pop-ThreadContext "NDC"
}

Function Trois {
  #Si on ne rdclare pas localement la proprit
  # on utilisera la dernire dclare, c'est  dire celle sur le haut de la pile.
Push-ThreadContext "NDC" $($myinvocation.MyCommand)
$LogMain.Info("Dans la fonction Trois")
$Null=Pop-ThreadContext "NDC"
}

$LogMain.Info("Appel la fonction Une ")
Une
$LogMain.Info("Fin")

Stop-log
